#include "doomsday.h"

#include <QtGui/QMessageBox>

Doomsday::Doomsday() {
	m_widget = new QWidget;

	m_startButton = new QPushButton("Start", m_widget);
	m_stopButton = new QPushButton("Stop", m_widget);
	m_secondsSpinBox = new QSpinBox(m_widget);
	m_secondsSpinBox->setMaximum(100000);
	m_secondsSpinBox->setMinimum(0);
	m_secondsSpinBox->setValue(60);
	m_secondsLabel = new QLabel("Not started", m_widget);

	m_layout = new QVBoxLayout(m_widget);
	m_widget->setLayout(m_layout);
	m_layout->addWidget(m_secondsSpinBox);
	m_layout->addWidget(m_startButton);
	m_layout->addWidget(m_stopButton);
	m_layout->addWidget(m_secondsLabel);

	connect(m_startButton, SIGNAL(clicked()), this, SLOT(startCountdown()));
	connect(m_stopButton, SIGNAL(clicked()), this, SLOT(stopCountdown()));

	m_timer = new QTimer(this);
	m_timer->setInterval(1000);
	connect(m_timer, SIGNAL(timeout()), this, SLOT(updateSeconds()));

	m_widget->show();
}

Doomsday::~Doomsday() {
	delete m_widget;
	//delete m_timer;
}

void Doomsday::updateSeconds() {
	--m_seconds;

	m_secondsLabel->setText(QString("Time left: %1").arg(m_seconds));

	if (m_seconds == 0) {
		emit destroyWorld();
		m_timer->stop();
	}
}

void Doomsday::startCountdown() {
	m_seconds = m_secondsSpinBox->value();
	m_timer->start();
	m_secondsLabel->setText(QString("Time left: %1").arg(m_seconds));
}

void Doomsday::stopCountdown() {
	m_timer->stop();
}

