#ifndef ANIMATION_WIDGET_HH
#define ANIMATION_WIDGET_HH

#include <QWidget>
#include <QObject>

#include <QRect>
#include <QPoint>
#include <QMouseEvent>
#include <QTimer>
#include <QTime>
#include <list>

class AnimationWidget : public QWidget {
  QTimer timer;
  QTime lastTime;
  std::list<QPointF> posHist;

 public:
  QPointF velocity;
  QPointF pos;
  float gravity;

  AnimationWidget(QWidget *parent, const QRect &geometry);
  ~AnimationWidget();
	
 protected:
  virtual void mousePressEvent(QMouseEvent * event);
  virtual void paintEvent(QPaintEvent * event);
};

#endif

